diff --git a/mediaportal/MiniDisplayLibrary/MiniDisplayPlugin/Drivers/ImonLcd_AdvancedSetupForm.Designer.cs b/mediaportal/MiniDisplayLibrary/MiniDisplayPlugin/Drivers/ImonLcd_AdvancedSetupForm.Designer.cs
new file mode 100644
index 0000000..64ef381
--- /dev/null
+++ b/mediaportal/MiniDisplayLibrary/MiniDisplayPlugin/Drivers/ImonLcd_AdvancedSetupForm.Designer.cs
@@ -0,0 +1,162 @@
+﻿namespace MediaPortal.ProcessPlugins.MiniDisplayPlugin.Drivers
+{
+    partial class ImonLcd_AdvancedSetupForm
+    {
+        /// <summary>
+        /// Required designer variable.
+        /// </summary>
+        private System.ComponentModel.IContainer components = null;
+
+        /// <summary>
+        /// Clean up any resources being used.
+        /// </summary>
+        /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
+        protected override void Dispose(bool disposing)
+        {
+            if (disposing && (components != null))
+            {
+                components.Dispose();
+            }
+            base.Dispose(disposing);
+        }
+
+        #region Windows Form Designer generated code
+
+        /// <summary>
+        /// Required method for Designer support - do not modify
+        /// the contents of this method with the code editor.
+        /// </summary>
+        private void InitializeComponent()
+        {
+            this.btnOK = new MediaPortal.UserInterface.Controls.MPButton();
+            this.gbxLineOptions = new System.Windows.Forms.GroupBox();
+            this.gbxPlayback = new System.Windows.Forms.GroupBox();
+            this.rbtnPlaybackSecondLine = new System.Windows.Forms.RadioButton();
+            this.rbtnPlaybackFirstLine = new System.Windows.Forms.RadioButton();
+            this.gbxGeneral = new System.Windows.Forms.GroupBox();
+            this.rbtnGeneralSecondLine = new System.Windows.Forms.RadioButton();
+            this.rbtnGeneralFirstLine = new System.Windows.Forms.RadioButton();
+            this.gbxLineOptions.SuspendLayout();
+            this.gbxPlayback.SuspendLayout();
+            this.gbxGeneral.SuspendLayout();
+            this.SuspendLayout();
+            // 
+            // btnOK
+            // 
+            this.btnOK.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
+            this.btnOK.Location = new System.Drawing.Point(244, 141);
+            this.btnOK.Name = "btnOK";
+            this.btnOK.Size = new System.Drawing.Size(78, 23);
+            this.btnOK.TabIndex = 7;
+            this.btnOK.Text = "&OK";
+            this.btnOK.UseVisualStyleBackColor = true;
+            this.btnOK.Click += new System.EventHandler(this.btnOK_Click);
+            // 
+            // gbxLineOptions
+            // 
+            this.gbxLineOptions.Controls.Add(this.gbxPlayback);
+            this.gbxLineOptions.Controls.Add(this.gbxGeneral);
+            this.gbxLineOptions.Location = new System.Drawing.Point(13, 13);
+            this.gbxLineOptions.Name = "gbxLineOptions";
+            this.gbxLineOptions.Size = new System.Drawing.Size(309, 123);
+            this.gbxLineOptions.TabIndex = 8;
+            this.gbxLineOptions.TabStop = false;
+            this.gbxLineOptions.Text = "Line Options";
+            // 
+            // gbxPlayback
+            // 
+            this.gbxPlayback.Controls.Add(this.rbtnPlaybackSecondLine);
+            this.gbxPlayback.Controls.Add(this.rbtnPlaybackFirstLine);
+            this.gbxPlayback.Location = new System.Drawing.Point(7, 69);
+            this.gbxPlayback.Name = "gbxPlayback";
+            this.gbxPlayback.Size = new System.Drawing.Size(296, 43);
+            this.gbxPlayback.TabIndex = 1;
+            this.gbxPlayback.TabStop = false;
+            this.gbxPlayback.Text = "During Playback";
+            // 
+            // rbtnPlaybackSecondLine
+            // 
+            this.rbtnPlaybackSecondLine.AutoSize = true;
+            this.rbtnPlaybackSecondLine.Location = new System.Drawing.Point(145, 18);
+            this.rbtnPlaybackSecondLine.Name = "rbtnPlaybackSecondLine";
+            this.rbtnPlaybackSecondLine.Size = new System.Drawing.Size(116, 17);
+            this.rbtnPlaybackSecondLine.TabIndex = 3;
+            this.rbtnPlaybackSecondLine.TabStop = true;
+            this.rbtnPlaybackSecondLine.Text = "Prefer Second Line";
+            this.rbtnPlaybackSecondLine.UseVisualStyleBackColor = true;
+            // 
+            // rbtnPlaybackFirstLine
+            // 
+            this.rbtnPlaybackFirstLine.AutoSize = true;
+            this.rbtnPlaybackFirstLine.Location = new System.Drawing.Point(7, 19);
+            this.rbtnPlaybackFirstLine.Name = "rbtnPlaybackFirstLine";
+            this.rbtnPlaybackFirstLine.Size = new System.Drawing.Size(98, 17);
+            this.rbtnPlaybackFirstLine.TabIndex = 2;
+            this.rbtnPlaybackFirstLine.TabStop = true;
+            this.rbtnPlaybackFirstLine.Text = "Prefer First Line";
+            this.rbtnPlaybackFirstLine.UseVisualStyleBackColor = true;
+            // 
+            // gbxGeneral
+            // 
+            this.gbxGeneral.Controls.Add(this.rbtnGeneralSecondLine);
+            this.gbxGeneral.Controls.Add(this.rbtnGeneralFirstLine);
+            this.gbxGeneral.Location = new System.Drawing.Point(7, 20);
+            this.gbxGeneral.Name = "gbxGeneral";
+            this.gbxGeneral.Size = new System.Drawing.Size(296, 43);
+            this.gbxGeneral.TabIndex = 0;
+            this.gbxGeneral.TabStop = false;
+            this.gbxGeneral.Text = "General";
+            // 
+            // rbtnGeneralSecondLine
+            // 
+            this.rbtnGeneralSecondLine.AutoSize = true;
+            this.rbtnGeneralSecondLine.Location = new System.Drawing.Point(145, 19);
+            this.rbtnGeneralSecondLine.Name = "rbtnGeneralSecondLine";
+            this.rbtnGeneralSecondLine.Size = new System.Drawing.Size(116, 17);
+            this.rbtnGeneralSecondLine.TabIndex = 1;
+            this.rbtnGeneralSecondLine.TabStop = true;
+            this.rbtnGeneralSecondLine.Text = "Prefer Second Line";
+            this.rbtnGeneralSecondLine.UseVisualStyleBackColor = true;
+            // 
+            // rbtnGeneralFirstLine
+            // 
+            this.rbtnGeneralFirstLine.AutoSize = true;
+            this.rbtnGeneralFirstLine.Location = new System.Drawing.Point(7, 20);
+            this.rbtnGeneralFirstLine.Name = "rbtnGeneralFirstLine";
+            this.rbtnGeneralFirstLine.Size = new System.Drawing.Size(98, 17);
+            this.rbtnGeneralFirstLine.TabIndex = 0;
+            this.rbtnGeneralFirstLine.TabStop = true;
+            this.rbtnGeneralFirstLine.Text = "Prefer First Line";
+            this.rbtnGeneralFirstLine.UseVisualStyleBackColor = true;
+            // 
+            // ImonLcd_AdvancedSetupForm
+            // 
+            this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
+            this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
+            this.ClientSize = new System.Drawing.Size(334, 176);
+            this.Controls.Add(this.gbxLineOptions);
+            this.Controls.Add(this.btnOK);
+            this.Name = "ImonLcd_AdvancedSetupForm";
+            this.StartPosition = System.Windows.Forms.FormStartPosition.CenterParent;
+            this.Text = "MiniDisplay - Setup - Advanced Settings";
+            this.gbxLineOptions.ResumeLayout(false);
+            this.gbxPlayback.ResumeLayout(false);
+            this.gbxPlayback.PerformLayout();
+            this.gbxGeneral.ResumeLayout(false);
+            this.gbxGeneral.PerformLayout();
+            this.ResumeLayout(false);
+
+        }
+
+        #endregion
+
+        private UserInterface.Controls.MPButton btnOK;
+        private System.Windows.Forms.GroupBox gbxLineOptions;
+        private System.Windows.Forms.GroupBox gbxPlayback;
+        private System.Windows.Forms.RadioButton rbtnPlaybackSecondLine;
+        private System.Windows.Forms.RadioButton rbtnPlaybackFirstLine;
+        private System.Windows.Forms.GroupBox gbxGeneral;
+        private System.Windows.Forms.RadioButton rbtnGeneralSecondLine;
+        private System.Windows.Forms.RadioButton rbtnGeneralFirstLine;
+    }
+}
\ No newline at end of file
diff --git a/mediaportal/MiniDisplayLibrary/MiniDisplayPlugin/Drivers/ImonLcd_AdvancedSetupForm.cs b/mediaportal/MiniDisplayLibrary/MiniDisplayPlugin/Drivers/ImonLcd_AdvancedSetupForm.cs
new file mode 100644
index 0000000..8956650
--- /dev/null
+++ b/mediaportal/MiniDisplayLibrary/MiniDisplayPlugin/Drivers/ImonLcd_AdvancedSetupForm.cs
@@ -0,0 +1,41 @@
+﻿using System;
+using MediaPortal.UserInterface.Controls;
+
+namespace MediaPortal.ProcessPlugins.MiniDisplayPlugin.Drivers
+{
+    public partial class ImonLcd_AdvancedSetupForm : MPConfigForm
+    {
+        public ImonLcd_AdvancedSetupForm()
+        {
+            InitializeComponent();
+
+            if (ImonLcd.AdvancedSettings.Instance.PreferFirstLineGeneral)
+            {
+                rbtnGeneralFirstLine.Checked = true;
+            }
+            else
+            {
+                rbtnGeneralSecondLine.Checked = true;
+            }
+
+            if (ImonLcd.AdvancedSettings.Instance.PreferFirstLinePlayback)
+            {
+                rbtnPlaybackFirstLine.Checked = true;
+            }
+            else
+            {
+                rbtnPlaybackSecondLine.Checked = true;
+            }
+        }
+
+        private void btnOK_Click(object sender, EventArgs e)
+        {
+            ImonLcd.AdvancedSettings.Instance.PreferFirstLineGeneral =
+                rbtnGeneralFirstLine.Checked;
+            ImonLcd.AdvancedSettings.Instance.PreferFirstLinePlayback =
+                rbtnPlaybackFirstLine.Checked;
+            ImonLcd.AdvancedSettings.Save();
+            Close();
+        }
+    }
+}
diff --git a/mediaportal/MiniDisplayLibrary/MiniDisplayPlugin/Drivers/ImonVfd.cs b/mediaportal/MiniDisplayLibrary/MiniDisplayPlugin/Drivers/ImonVfd.cs
new file mode 100644
index 0000000..89a6423
--- /dev/null
+++ b/mediaportal/MiniDisplayLibrary/MiniDisplayPlugin/Drivers/ImonVfd.cs
@@ -0,0 +1,42 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Drawing;
+using System.Runtime.InteropServices;
+using System.Text;
+using MediaPortal.GUI.Library;
+
+namespace MediaPortal.ProcessPlugins.MiniDisplayPlugin.Drivers
+{
+    /// <summary>
+    /// iMON VFD Driver for iMON Manager >= 8.01.0419
+    /// </summary>
+    public class ImonVfd : ImonBase
+    {
+        public ImonVfd()
+        {
+            UnsupportedDeviceErrorMessage = "Only VFDs are supported";
+            Description = "iMON VFD for iMON Manager >= 8.01.0419";
+            Name = "iMONVFD";
+            DisplayType = DSPN_DSP_VFD;
+        }
+
+        public override void SetLine(int line, string message)
+        {
+            if (line == 0)
+            {
+                Line1 = message;
+            }
+            else if (line == 1)
+            {
+                Line2 = message;
+                IDW_SetVfdText(Line1, Line2);
+            }
+        }
+
+        [DllImport("iMONDisplayWrapper.dll")]
+        private static extern int IDW_SetVfdText(
+          [MarshalAs(UnmanagedType.LPWStr)] string line1,
+          [MarshalAs(UnmanagedType.LPWStr)] string line2);
+
+    }
+}
diff --git a/mediaportal/MiniDisplayLibrary/MiniDisplayPlugin/Drivers/iMONDisplayWrapper/Event.cpp b/mediaportal/MiniDisplayLibrary/MiniDisplayPlugin/Drivers/iMONDisplayWrapper/Event.cpp
new file mode 100644
index 0000000..d0f66fd
--- /dev/null
+++ b/mediaportal/MiniDisplayLibrary/MiniDisplayPlugin/Drivers/iMONDisplayWrapper/Event.cpp
@@ -0,0 +1,29 @@
+//------------------------------------------------------------------------------
+#include "Event.h"
+//------------------------------------------------------------------------------
+Event::Event()
+{
+  m_hEvent = CreateEvent(NULL, TRUE, FALSE, NULL);
+}
+//------------------------------------------------------------------------------
+Event::~Event()
+{
+  if (m_hEvent)
+    CloseHandle(m_hEvent);
+}
+//------------------------------------------------------------------------------
+void Event::Signal() const
+{
+  SetEvent(m_hEvent);
+}
+//------------------------------------------------------------------------------
+void Event::Reset() const
+{
+  ResetEvent(m_hEvent);
+}
+//------------------------------------------------------------------------------
+void Event::Await() const
+{
+  WaitForSingleObject(m_hEvent, INFINITE);
+}
+//------------------------------------------------------------------------------
diff --git a/mediaportal/MiniDisplayLibrary/MiniDisplayPlugin/Drivers/iMONDisplayWrapper/Event.h b/mediaportal/MiniDisplayLibrary/MiniDisplayPlugin/Drivers/iMONDisplayWrapper/Event.h
new file mode 100644
index 0000000..d5c1b68
--- /dev/null
+++ b/mediaportal/MiniDisplayLibrary/MiniDisplayPlugin/Drivers/iMONDisplayWrapper/Event.h
@@ -0,0 +1,27 @@
+//------------------------------------------------------------------------------
+#ifndef EVENT_H_INCLUDED
+#define EVENT_H_INCLUDED
+//------------------------------------------------------------------------------
+#include <windows.h>
+//------------------------------------------------------------------------------
+class Event
+{
+public:
+  Event();
+  virtual ~Event();
+
+private:
+  Event(const Event& other) {}
+  Event& operator=(const Event& other) { return *this; }
+
+public:
+  void Signal() const;
+  void Reset() const;
+  void Await() const;
+
+private:
+  HANDLE m_hEvent;
+};
+//------------------------------------------------------------------------------
+#endif
+//------------------------------------------------------------------------------
diff --git a/mediaportal/MiniDisplayLibrary/MiniDisplayPlugin/Drivers/iMONDisplayWrapper/IdwApi.cpp b/mediaportal/MiniDisplayLibrary/MiniDisplayPlugin/Drivers/iMONDisplayWrapper/IdwApi.cpp
new file mode 100644
index 0000000..5244191
--- /dev/null
+++ b/mediaportal/MiniDisplayLibrary/MiniDisplayPlugin/Drivers/iMONDisplayWrapper/IdwApi.cpp
@@ -0,0 +1,247 @@
+//------------------------------------------------------------------------------
+#include "IdwApi.h"
+#include <windows.h>
+//------------------------------------------------------------------------------
+IdwApi::IdwApi(HINSTANCE hInstance)
+: m_hInstance(hInstance)
+, m_pIdwThread(NULL)
+, m_nInitCount(0)
+{
+}
+//------------------------------------------------------------------------------
+IdwApi::~IdwApi()
+{
+}
+//------------------------------------------------------------------------------
+DSPResult IdwApi::Init(IDW_INITRESULT* pInitResult)
+{
+  m_mutex.Request();
+  if (m_nInitCount == 0)
+  {
+    m_pIdwThread = new IdwThread(m_hInstance);
+    m_pIdwThread->Start();
+  }
+  ++m_nInitCount;
+  DSPResult ret = m_pIdwThread->Init(pInitResult);
+  m_mutex.Release();
+  return ret;
+}
+//------------------------------------------------------------------------------
+DSPResult IdwApi::Uninit()
+{
+  m_mutex.Request();
+  if (m_nInitCount == 0)
+  {
+    m_mutex.Release();
+    return DSP_E_NOT_INITED;
+  }
+  DSPResult ret = m_pIdwThread->Uninit();
+  if (ret == DSP_SUCCEEDED)
+  {
+    --m_nInitCount;
+    if (m_nInitCount == 0)
+    {
+      m_pIdwThread->Interrupt();
+      m_pIdwThread->Join();
+      delete m_pIdwThread;
+    }
+  }
+  m_mutex.Release();
+  return ret;
+}
+//------------------------------------------------------------------------------
+DSPResult IdwApi::IsInited()
+{
+  m_mutex.Request();
+  if (m_nInitCount == 0)
+  {
+    m_mutex.Release();
+    return DSP_S_NOT_INITED;
+  }
+  DSPResult ret = m_pIdwThread->IsInited();
+  m_mutex.Release();
+  return ret;
+}
+//------------------------------------------------------------------------------
+DSPResult IdwApi::IsPluginModeEnabled()
+{
+  m_mutex.Request();
+  if (m_nInitCount == 0)
+  {
+    m_mutex.Release();
+    return DSP_S_NOT_IN_PLUGIN_MODE;
+  }
+  DSPResult ret = m_pIdwThread->IsPluginModeEnabled();
+  m_mutex.Release();
+  return ret;
+}
+//------------------------------------------------------------------------------
+DSPResult IdwApi::SetVfdText(LPCWSTR lpszLine1, LPCWSTR lpszLine2)
+{
+  m_mutex.Request();
+  if (m_nInitCount == 0)
+  {
+    m_mutex.Release();
+    return DSP_E_NOT_INITED;
+  }
+  DSPResult ret = m_pIdwThread->SetVfdText(lpszLine1, lpszLine2);
+  m_mutex.Release();
+  return ret;
+}
+//------------------------------------------------------------------------------
+DSPResult IdwApi::SetVfdEqData(PDSPEQDATA pEqData)
+{
+  m_mutex.Request();
+  if (m_nInitCount == 0)
+  {
+    m_mutex.Release();
+    return DSP_E_NOT_INITED;
+  }
+  DSPResult ret = m_pIdwThread->SetVfdEqData(pEqData);
+  m_mutex.Release();
+  return ret;
+}
+//------------------------------------------------------------------------------
+DSPResult IdwApi::SetLcdText(LPCWSTR lpszLine1)
+{
+  m_mutex.Request();
+  if (m_nInitCount == 0)
+  {
+    m_mutex.Release();
+    return DSP_E_NOT_INITED;
+  }
+  DSPResult ret = m_pIdwThread->SetLcdText(lpszLine1);
+  m_mutex.Release();
+  return ret;
+}
+//------------------------------------------------------------------------------
+DSPResult IdwApi::SetLcdEqData(PDSPEQDATA pEqDataL, PDSPEQDATA pEqDataR)
+{
+  m_mutex.Request();
+  if (m_nInitCount == 0)
+  {
+    m_mutex.Release();
+    return DSP_E_NOT_INITED;
+  }
+  DSPResult ret = m_pIdwThread->SetLcdEqData(pEqDataL, pEqDataR);
+  m_mutex.Release();
+  return ret;
+}
+//------------------------------------------------------------------------------
+DSPResult IdwApi::SetLcdAllIcons(BOOL bOn)
+{
+  m_mutex.Request();
+  if (m_nInitCount == 0)
+  {
+    m_mutex.Release();
+    return DSP_E_NOT_INITED;
+  }
+  DSPResult ret = m_pIdwThread->SetLcdAllIcons(bOn);
+  m_mutex.Release();
+  return ret;
+}
+//------------------------------------------------------------------------------
+DSPResult IdwApi::SetLcdOrangeIcon(BYTE btIconData1, BYTE btIconData2)
+{
+  m_mutex.Request();
+  if (m_nInitCount == 0)
+  {
+    m_mutex.Release();
+    return DSP_E_NOT_INITED;
+  }
+  DSPResult ret = m_pIdwThread->SetLcdOrangeIcon(btIconData1, btIconData2);
+  m_mutex.Release();
+  return ret;
+}
+//------------------------------------------------------------------------------
+DSPResult IdwApi::SetLcdMediaTypeIcon(BYTE btIconData)
+{
+  m_mutex.Request();
+  if (m_nInitCount == 0)
+  {
+    m_mutex.Release();
+    return DSP_E_NOT_INITED;
+  }
+  DSPResult ret = m_pIdwThread->SetLcdMediaTypeIcon(btIconData);
+  m_mutex.Release();
+  return ret;
+}
+//------------------------------------------------------------------------------
+DSPResult IdwApi::SetLcdSpeakerIcon(BYTE btIconData1, BYTE btIconData2)
+{
+  m_mutex.Request();
+  if (m_nInitCount == 0)
+  {
+    m_mutex.Release();
+    return DSP_E_NOT_INITED;
+  }
+  DSPResult ret = m_pIdwThread->SetLcdSpeakerIcon(btIconData1, btIconData2);
+  m_mutex.Release();
+  return ret;
+}
+//------------------------------------------------------------------------------
+DSPResult IdwApi::SetLcdVideoCodecIcon(BYTE btIconData)
+{
+  m_mutex.Request();
+  if (m_nInitCount == 0)
+  {
+    m_mutex.Release();
+    return DSP_E_NOT_INITED;
+  }
+  DSPResult ret = m_pIdwThread->SetLcdVideoCodecIcon(btIconData);
+  m_mutex.Release();
+  return ret;
+}
+//------------------------------------------------------------------------------
+DSPResult IdwApi::SetLcdAudioCodecIcon(BYTE btIconData)
+{
+  m_mutex.Request();
+  if (m_nInitCount == 0)
+  {
+    m_mutex.Release();
+    return DSP_E_NOT_INITED;
+  }
+  DSPResult ret = m_pIdwThread->SetLcdAudioCodecIcon(btIconData);
+  m_mutex.Release();
+  return ret;
+}
+//------------------------------------------------------------------------------
+DSPResult IdwApi::SetLcdAspectRatioIcon(BYTE btIconData)
+{
+  m_mutex.Request();
+  if (m_nInitCount == 0)
+  {
+    m_mutex.Release();
+    return DSP_E_NOT_INITED;
+  }
+  DSPResult ret = m_pIdwThread->SetLcdAspectRatioIcon(btIconData);
+  m_mutex.Release();
+  return ret;
+}
+//------------------------------------------------------------------------------
+DSPResult IdwApi::SetLcdEtcIcon(BYTE btIconData)
+{
+  m_mutex.Request();
+  if (m_nInitCount == 0)
+  {
+    m_mutex.Release();
+    return DSP_E_NOT_INITED;
+  }
+  DSPResult ret = m_pIdwThread->SetLcdEtcIcon(btIconData);
+  m_mutex.Release();
+  return ret;
+}
+//------------------------------------------------------------------------------
+DSPResult IdwApi::SetLcdProgress(int nCurPos, int nTotal)
+{
+  m_mutex.Request();
+  if (m_nInitCount == 0)
+  {
+    m_mutex.Release();
+    return DSP_E_NOT_INITED;
+  }
+  DSPResult ret = m_pIdwThread->SetLcdProgress(nCurPos, nTotal);
+  m_mutex.Release();
+  return ret;
+}
+//------------------------------------------------------------------------------
\ No newline at end of file
diff --git a/mediaportal/MiniDisplayLibrary/MiniDisplayPlugin/Drivers/iMONDisplayWrapper/IdwApi.h b/mediaportal/MiniDisplayLibrary/MiniDisplayPlugin/Drivers/iMONDisplayWrapper/IdwApi.h
new file mode 100644
index 0000000..460d1ca
--- /dev/null
+++ b/mediaportal/MiniDisplayLibrary/MiniDisplayPlugin/Drivers/iMONDisplayWrapper/IdwApi.h
@@ -0,0 +1,48 @@
+//------------------------------------------------------------------------------
+#ifndef IDWAPI_H_INCLUDED
+#define IDWAPI_H_INCLUDED
+//------------------------------------------------------------------------------
+#include <windows.h>
+#include "Mutex.h"
+#include "iMONDisplayDefines.h"
+#include "iMONDisplayWrapper.h"
+#include "IdwThread.h"
+//------------------------------------------------------------------------------
+class IdwApi
+{
+public:
+  IdwApi(HINSTANCE hInstance);
+  ~IdwApi();
+
+public:
+  DSPResult Init(IDW_INITRESULT* pInitResult);
+  DSPResult Uninit();
+  DSPResult IsInited();
+  DSPResult IsPluginModeEnabled();
+  DSPResult SetVfdText(LPCWSTR lpszLine1, LPCWSTR lpszLine2);
+  DSPResult SetVfdEqData(PDSPEQDATA pEqData);
+  DSPResult SetLcdText(LPCWSTR lpszText);
+  DSPResult SetLcdEqData(PDSPEQDATA pEqDataL, PDSPEQDATA pEqDataR);
+  DSPResult SetLcdAllIcons(BOOL bOn);
+  DSPResult SetLcdOrangeIcon(BYTE btIconData1, BYTE btIconData2);
+  DSPResult SetLcdMediaTypeIcon(BYTE btIconData);
+  DSPResult SetLcdSpeakerIcon(BYTE btIconData1, BYTE btIconData2);
+  DSPResult SetLcdVideoCodecIcon(BYTE btIconData);
+  DSPResult SetLcdAudioCodecIcon(BYTE btIconData);
+  DSPResult SetLcdAspectRatioIcon(BYTE btIconData);
+  DSPResult SetLcdEtcIcon(BYTE btIconData);
+  DSPResult SetLcdProgress(int nCurPos, int nTotal);
+
+private:
+  IdwApi(const IdwApi& other) {}
+  IdwApi& operator=(const IdwApi& other) { return *this; }
+
+private:
+  HINSTANCE m_hInstance;
+  Mutex m_mutex;
+  int m_nInitCount;
+  IdwThread* m_pIdwThread;
+};
+//------------------------------------------------------------------------------
+#endif
+//------------------------------------------------------------------------------
